'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _saralaJsonApiDataFormatter = require('sarala-json-api-data-formatter');

var _QueryBuilder = require('./QueryBuilder');

var _QueryBuilder2 = _interopRequireDefault(_QueryBuilder);

var _config = require('./config');

var _UnimplementedException = require('../../exceptions/src/exceptions/UnimplementedException');

var _UnimplementedException2 = _interopRequireDefault(_UnimplementedException);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var formatter = new _saralaJsonApiDataFormatter.Formatter();

var Model = function () {
    function Model() {
        (0, _classCallCheck3.default)(this, Model);

        this.queryBuilder = new _QueryBuilder2.default();
        this.selfValidate();
        this.type = this.getNamespace();
    }

    // override

    (0, _createClass3.default)(Model, [{
        key: 'getFields',
        value: function getFields() {
            throw (0, _UnimplementedException2.default)("Method getFields() must be implemented in every child class.");
        }
    }, {
        key: 'getDates',
        value: function getDates() {
            throw (0, _UnimplementedException2.default)("Method getDates() must be implemented in every child class.");
        }
    }, {
        key: 'getRelations',
        value: function getRelations() {
            throw (0, _UnimplementedException2.default)("Method getRelations() must be implemented in every child class.");
        }
    }, {
        key: 'computed',
        value: function computed() {
            throw (0, _UnimplementedException2.default)("Method computed() must be implemented in every child class.");
        }
    }, {
        key: 'getNamespace',
        value: function getNamespace() {
            throw (0, _UnimplementedException2.default)("Method getNamespace() must be implemented in every child class.");
        }
    }, {
        key: 'dateFormat',
        value: function dateFormat() {
            return 'YYYY-MM-DD HH:mm';
        }
    }, {
        key: 'getBaseUrl',
        value: function getBaseUrl() {
            return _config.config.base_url;
        }
    }, {
        key: 'request',
        value: function () {
            var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(config) {
                return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                throw (0, _UnimplementedException2.default)("Method request() must be implemented in base model.");

                            case 1:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            function request(_x) {
                return _ref.apply(this, arguments);
            }

            return request;
        }()

        // requests

    }, {
        key: 'find',
        value: function () {
            var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(id) {
                var response;
                return _regenerator2.default.wrap(function _callee2$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                _context2.next = 2;
                                return this.request({
                                    url: '' + this.resourceUrl() + id + this.queryBuilder.getQuery(),
                                    method: _config.config.http_methods.get
                                });

                            case 2:
                                response = _context2.sent;
                                return _context2.abrupt('return', this.respond(response.data));

                            case 4:
                            case 'end':
                                return _context2.stop();
                        }
                    }
                }, _callee2, this);
            }));

            function find(_x2) {
                return _ref2.apply(this, arguments);
            }

            return find;
        }()
    }, {
        key: 'all',
        value: function () {
            var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
                var response;
                return _regenerator2.default.wrap(function _callee3$(_context3) {
                    while (1) {
                        switch (_context3.prev = _context3.next) {
                            case 0:
                                _context3.next = 2;
                                return this.request({
                                    url: '' + this.resourceUrl() + this.queryBuilder.getQuery(),
                                    method: _config.config.http_methods.get
                                });

                            case 2:
                                response = _context3.sent;
                                return _context3.abrupt('return', this.respond(response.data));

                            case 4:
                            case 'end':
                                return _context3.stop();
                        }
                    }
                }, _callee3, this);
            }));

            function all() {
                return _ref3.apply(this, arguments);
            }

            return all;
        }()
    }, {
        key: 'paginate',
        value: function () {
            var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4() {
                var perPage = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 10;
                var page = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
                var response;
                return _regenerator2.default.wrap(function _callee4$(_context4) {
                    while (1) {
                        switch (_context4.prev = _context4.next) {
                            case 0:
                                this.queryBuilder.paginate(perPage, page);

                                _context4.next = 3;
                                return this.request({
                                    url: '' + this.resourceUrl() + this.queryBuilder.getQuery(),
                                    method: _config.config.http_methods.get
                                });

                            case 3:
                                response = _context4.sent;
                                return _context4.abrupt('return', this.respond(response.data));

                            case 5:
                            case 'end':
                                return _context4.stop();
                        }
                    }
                }, _callee4, this);
            }));

            function paginate() {
                return _ref4.apply(this, arguments);
            }

            return paginate;
        }()
    }, {
        key: 'save',
        value: function () {
            var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5() {
                return _regenerator2.default.wrap(function _callee5$(_context5) {
                    while (1) {
                        switch (_context5.prev = _context5.next) {
                            case 0:
                                if (!this.hasOwnProperty('id')) {
                                    _context5.next = 2;
                                    break;
                                }

                                return _context5.abrupt('return', this.update());

                            case 2:
                                return _context5.abrupt('return', this.create());

                            case 3:
                            case 'end':
                                return _context5.stop();
                        }
                    }
                }, _callee5, this);
            }));

            function save() {
                return _ref5.apply(this, arguments);
            }

            return save;
        }()
    }, {
        key: 'create',
        value: function () {
            var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6() {
                var response;
                return _regenerator2.default.wrap(function _callee6$(_context6) {
                    while (1) {
                        switch (_context6.prev = _context6.next) {
                            case 0:
                                _context6.next = 2;
                                return this.request({
                                    url: this.resourceUrl(),
                                    method: _config.config.http_methods.create,
                                    data: this.serialize(this.data())
                                });

                            case 2:
                                response = _context6.sent;
                                return _context6.abrupt('return', this.respond(response.data));

                            case 4:
                            case 'end':
                                return _context6.stop();
                        }
                    }
                }, _callee6, this);
            }));

            function create() {
                return _ref6.apply(this, arguments);
            }

            return create;
        }()
    }, {
        key: 'update',
        value: function () {
            var _ref7 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee7() {
                var response;
                return _regenerator2.default.wrap(function _callee7$(_context7) {
                    while (1) {
                        switch (_context7.prev = _context7.next) {
                            case 0:
                                _context7.next = 2;
                                return this.request({
                                    url: this.links.self,
                                    method: _config.config.http_methods.update,
                                    data: this.serialize(this.data())
                                });

                            case 2:
                                response = _context7.sent;
                                return _context7.abrupt('return', this.respond(response.data));

                            case 4:
                            case 'end':
                                return _context7.stop();
                        }
                    }
                }, _callee7, this);
            }));

            function update() {
                return _ref7.apply(this, arguments);
            }

            return update;
        }()
    }, {
        key: 'delete',
        value: function () {
            var _ref8 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee8() {
                var response;
                return _regenerator2.default.wrap(function _callee8$(_context8) {
                    while (1) {
                        switch (_context8.prev = _context8.next) {
                            case 0:
                                response = this.request({
                                    url: this.links.self,
                                    method: _config.config.http_methods.delete
                                });
                                return _context8.abrupt('return', this.respond(response.data));

                            case 2:
                            case 'end':
                                return _context8.stop();
                        }
                    }
                }, _callee8, this);
            }));

            function _delete() {
                return _ref8.apply(this, arguments);
            }

            return _delete;
        }()
    }, {
        key: 'attach',
        value: function () {
            var _ref9 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee9(model) {
                var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
                var queryConfig, response;
                return _regenerator2.default.wrap(function _callee9$(_context9) {
                    while (1) {
                        switch (_context9.prev = _context9.next) {
                            case 0:
                                queryConfig = {
                                    url: this.links.self + '/' + model.type + '/' + model.id,
                                    method: _config.config.http_methods.create
                                };


                                if (data) {
                                    queryConfig.data = data;
                                }

                                _context9.next = 4;
                                return this.request(queryConfig);

                            case 4:
                                response = _context9.sent;
                                return _context9.abrupt('return', this.respond(response.data));

                            case 6:
                            case 'end':
                                return _context9.stop();
                        }
                    }
                }, _callee9, this);
            }));

            function attach(_x5) {
                return _ref9.apply(this, arguments);
            }

            return attach;
        }()
    }, {
        key: 'detach',
        value: function () {
            var _ref10 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee10(model) {
                var response;
                return _regenerator2.default.wrap(function _callee10$(_context10) {
                    while (1) {
                        switch (_context10.prev = _context10.next) {
                            case 0:
                                _context10.next = 2;
                                return this.request({
                                    url: this.links.self + '/' + model.type + '/' + model.id,
                                    method: _config.config.http_methods.delete
                                });

                            case 2:
                                response = _context10.sent;
                                return _context10.abrupt('return', this.respond(response.data));

                            case 4:
                            case 'end':
                                return _context10.stop();
                        }
                    }
                }, _callee10, this);
            }));

            function detach(_x7) {
                return _ref10.apply(this, arguments);
            }

            return detach;
        }()
    }, {
        key: 'sync',
        value: function () {
            var _ref11 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee11(relationship) {
                var data, respond;
                return _regenerator2.default.wrap(function _callee11$(_context11) {
                    while (1) {
                        switch (_context11.prev = _context11.next) {
                            case 0:
                                data = this.serialize(this.data());
                                _context11.next = 3;
                                return this.request({
                                    url: this.links.self + '/' + relationship,
                                    method: _config.config.http_methods.update,
                                    data: data.data.relationships[relationship]
                                });

                            case 3:
                                respond = _context11.sent;
                                return _context11.abrupt('return', this.respond(respond.data));

                            case 5:
                            case 'end':
                                return _context11.stop();
                        }
                    }
                }, _callee11, this);
            }));

            function sync(_x8) {
                return _ref11.apply(this, arguments);
            }

            return sync;
        }()

        // modify query string

    }, {
        key: 'with',
        value: function _with() {
            var _queryBuilder;

            (_queryBuilder = this.queryBuilder).with.apply(_queryBuilder, arguments);

            return this;
        }
    }, {
        key: 'orderBy',
        value: function orderBy(column) {
            var direction = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'asc';

            this.queryBuilder.orderBy(column, direction);

            return this;
        }
    }, {
        key: 'limit',
        value: function limit(_limit, offset) {
            this.queryBuilder.limit(_limit, offset);

            return this;
        }

        // paginate(pageNumber, perPage = 10) {
        //     this.queryBuilder.paginate(pageNumber, perPage);
        //
        //     return this;
        // }

    }, {
        key: 'orderByDesc',
        value: function orderByDesc(column) {
            return this.orderBy(column, 'desc');
        }
    }, {
        key: 'where',
        value: function where(key, operator) {
            var value = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

            this.queryBuilder.where(key, operator, value);

            return this;
        }
    }, {
        key: 'from',
        value: function from(date) {
            this.queryBuilder(date);

            return this;
        }
    }, {
        key: 'to',
        value: function to(date) {
            this.queryBuilder.to(date);

            return this;
        }
    }, {
        key: 'select',
        value: function select() {
            var _queryBuilder2;

            (_queryBuilder2 = this.queryBuilder).select.apply(_queryBuilder2, arguments);

            return this;
        }
    }, {
        key: 'distinct',
        value: function distinct() {
            var bool = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;

            this.queryBuilder.distinct(bool);

            return this;
        }

        // build model

    }, {
        key: 'respond',
        value: function respond(response) {
            if (!_lodash2.default.isEmpty(response)) {
                var data = this.deserialize(response);

                if (this.isCollection(data)) {
                    return this.resolveCollection(data);
                }

                return this.resolveItem(data);
            }

            return null;
        }
    }, {
        key: 'resolveCollection',
        value: function resolveCollection(data) {
            var thiss = this;
            var resolved = {};

            if (data.hasOwnProperty('links')) {
                resolved.links = data.links;
            }

            if (data.hasOwnProperty('meta')) {
                resolved.meta = data.meta;
            }

            resolved.data = _lodash2.default.map(data.data, function (item) {
                return thiss.resolveItem(item);
            });

            return resolved;
        }
    }, {
        key: 'resolveItem',
        value: function resolveItem(data) {
            return this.hydrate(data);
        }
    }, {
        key: 'hydrate',
        value: function hydrate(data) {
            var model = _lodash2.default.clone(this);

            model.id = data.id;
            model.type = data.type;

            if (data.hasOwnProperty('getRelations')) {
                model.relationshipNames = data.relationships;
            }

            if (data.hasOwnProperty('links')) {
                model.links = data.links;
            }

            _lodash2.default.forEach(this.getFields(), function (field) {
                model[field] = data[field];
            });

            _lodash2.default.forEach(this.getDates(), function (field) {
                model[field] = (0, _moment2.default)(data[field]);
            });

            var thiss = this;

            _lodash2.default.forEach(data.relationships, function (relationship) {
                var relation = model.relationships()[relationship];

                if (_lodash2.default.isUndefined(relation)) {
                    throw new Error('Sarale: Relationship ' + relationship + ' has not been defined in ' + model.constructor.name + ' model.');
                }

                if (thiss.isCollection(data[relationship])) {
                    model[relationship] = relation.resolveCollection(data[relationship]);
                } else {
                    model[relationship] = relation.resolveItem(data[relationship].data);
                }
            });

            _lodash2.default.forOwn(model.computed(), function (computation, key) {
                model[key] = computation(model);
            });

            return model;
        }

        // extract data from model


    }, {
        key: 'data',
        value: function data() {
            var _this = this;

            var data = {};

            data.type = this.type;

            if (this.hasOwnProperty('id')) {
                data.id = this.id;
            }

            if (this.hasOwnProperty('relationshipNames')) {
                data.relationships = this.relationshipNames;
            }

            _lodash2.default.forEach(this.getFields(), function (field) {
                if (!_lodash2.default.isUndefined(_this[field])) {
                    data[field] = _this[field];
                }
            });

            _lodash2.default.forEach(this.getDates(), function (field) {
                if (!_lodash2.default.isUndefined(_this[field])) {
                    data[field] = _this[field].format(_this.dateFormat());
                }
            });

            var thiss = this;

            _lodash2.default.forEach(thiss.getRelations(), function (model, relationship) {
                if (!_lodash2.default.isUndefined(thiss[relationship])) {
                    if (_lodash2.default.isArray(thiss[relationship].data)) {
                        data[relationship] = {
                            data_collection: true,
                            data: _lodash2.default.map(thiss[relationship].data, function (relation) {
                                return relation.data();
                            })
                        };
                    } else {
                        data[relationship] = {
                            data: thiss[relationship].data()
                        };
                    }
                }
            });

            return data;
        }

        // helpers

    }, {
        key: 'resourceUrl',
        value: function resourceUrl() {
            return this.getBaseUrl() + '/' + this.getNamespace() + '/';
        }
    }, {
        key: 'isCollection',
        value: function isCollection(data) {
            return data.hasOwnProperty('data_collection') && data.data_collection === true && _lodash2.default.isArray(data.data);
        }
    }, {
        key: 'deserialize',
        value: function deserialize(data) {
            return formatter.deserialize(data);
        }
    }, {
        key: 'serialize',
        value: function serialize(data) {
            return formatter.serialize(data);
        }
    }, {
        key: 'selfValidate',
        value: function selfValidate() {
            var name = this.getNamespace();

            if (name === null || !_lodash2.default.isString(name) || name.length === 0) {
                throw new Error('Sarale: Resource name not defined in ' + this.constructor.name + ' model. Implement resourceName method in the ' + this.constructor.name + ' model to resolve this error.');
            }
        }
    }]);
    return Model;
}();

exports.default = Model;